# Overview

The charm installs [Graylog](https://www.graylog.org/) using the [snap package](https://uappexplorer.com/snap/ubuntu/graylog).
The charm must be related to elasticsearch and mongodb in order to be a fully functioning installation.
Also note Graylog doesn't support all versions of elasticsearch see the [documentation](http://docs.graylog.org/en/2.2/pages/installation.html) for more details.

# Usage

juju deploy graylog
juju config graylog admin_password_hash="8c6976e5b5410415bde908bd4dee15dfb167a9c873fc4bb8a81f6f2ab448a918"

Graylog requires MongoDB to run and Elasticsearch to be useful.

juju deploy cs:mongodb
juju relate graylog:mongodb mongodb:database
juju deploy cs:~ivoks/elasticsearch
juju relate graylog:elasticsearch elasticsearch:client

You can then browse to http://ip-address:9000 and log in as admin with the password matching the hash specified, also admin in the example.

## Reverseproxy Relation
Graylog supports advertising its web and api ports to an application acting as a reverseproxy using the http relation.
The port of the webUI is exposed over the relation as is the port for both the webUI and API in the all_services variable of the relation.
More details on using this are in the reverseproxy instructions for the [Apache2 charm](https://jujucharms.com/apache2/).

## Scale out Usage

The MongoDB and Elasticsearch applications can both be scaled to clusters and Graylog will adapt to using the cluster.
The Graylog charm does not yet support clustering of multiple units.

# Configuration

The administrator password is by default a random value so admin_password_hash must be set for admin access to the installation.

Depending on the Elasticsearch charm used the cluster name may not be passed in the relation in which case it the `elasticsearch_cluster_name` config option should be set.
